﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Windows.Forms;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.Common.Helpers;
using Styx.Plugins;
using System.Diagnostics;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System.Media;
using System.Threading;

namespace DropAlert
{
    public partial class DropAlert : HBPlugin
    {
       
        private readonly string _alertListPath = Path.Combine(AppDomain.CurrentDomain.BaseDirectory,
            string.Format(@"Plugins/DropAlert/Lists/alertList.txt"));

        public List<string> alertList = new List<string>();
        private Stopwatch antispam = new Stopwatch();

     

        public override string Name { get { return "DropAlert"; } }
    
        
        public override string Author
        {
            get { return "bcrazy"; }
        }

        public override Version Version
        {
            get { return new Version(0, 0, 1); }
        }

        public override bool WantButton
        {
            get { return true; }
        }

        public override string ButtonText
        {
            get { return "DropAlert"; }
        }



        private static LocalPlayer Me
        {
            get { return StyxWoW.Me; }
        }

		 public override void OnEnable()
        {
            LoadList(alertList, _alertListPath);
        }
        
		
		
		
		private void alertSnd()
        {
            try
            {
                SoundPlayer sp = new SoundPlayer();
                sp.SoundLocation = Application.StartupPath + @"\Plugins\DropAlert\Sounds\boing.wav";
                sp.Play();
            }
            catch (Exception e) { Logging.Write("Error: Could not play audio.\n" + e.Message); }
        }
		
       public void CheckForItems()
        {
		 LoadList(alertList, _alertListPath);
		 
		foreach (WoWItem item in Me.BagItems)
                {
				if (alertList.Contains(item.Name))
					{
		
					Logging.Write(Colors.Gold, "DROP ALERT! ---- Dropped ITEM --- " + item.Name);
					alertSnd();
					}
				
				}
		}
		

        public override void Pulse()
        {
		
		antispam.Start();
		
           if (antispam.Elapsed.TotalSeconds > 30)
		   
		   {
		   CheckForItems();
		   antispam.Reset();
		   
		   }
			
			
		}	

        

        public void LoadList(List<string> listToLoad, string filePath)
        {
            listToLoad.Clear();
            try
            {
                using (var read = new StreamReader(Convert.ToString(filePath)))
                {
                    while (read.Peek() >= 0)
                    {
                        listToLoad.Add(Convert.ToString(read.ReadLine()));
                    }
                    read.Close();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(Convert.ToString(ex.Message));
            }
        }

        

        
    }
}